/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.Logger
 *  fire.msp.move.GGoto
 *  fire.msp.move.GGotoRandom
 *  fire.msp.move.GGotoRandomInARegion
 *  fire.pb.GsClient
 *  fire.pb.buff.BuffRoleImpl
 *  fire.pb.main.ConfigManager
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.CGPlayUtil
 *  fire.pb.util.FireProp
 *  mkdb.Transaction
 *  mkio.Protocol
 */
package fire.pb.map;

import fire.log.Logger;
import fire.msp.move.GGoto;
import fire.msp.move.GGotoRandom;
import fire.msp.move.GGotoRandomInARegion;
import fire.pb.GsClient;
import fire.pb.buff.BuffRoleImpl;
import fire.pb.main.ConfigManager;
import fire.pb.map.MapConfig;
import fire.pb.map.PPreGotoProcess;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.CGPlayUtil;
import fire.pb.util.FireProp;
import java.util.Iterator;
import mkdb.Transaction;
import mkio.Protocol;

public final class Transfer {
    public static Logger logger = Logger.getLogger((String)"MAPMAIN");

    public static int checkCanChangeMap(long roleId, int gototype) {
        BuffRoleImpl buffRoleImpl = new BuffRoleImpl(roleId, true);
        int conflictId = buffRoleImpl.checkBuffClash(gototype);
        if (conflictId > 0) {
            return conflictId;
        }
        return 0;
    }

    public static void sendMsgWhileCanntGoto(long roleId, int conflictId) {
        switch (conflictId) {
            case 507009: {
                MessageMgr.sendMsgNotify((long)roleId, (int)141216, null);
                return;
            }
            case 507004: {
                MessageMgr.sendMsgNotify((long)roleId, (int)141214, null);
                return;
            }
            case 507005: {
                return;
            }
            case 507027: {
                return;
            }
            case 507020: {
                return;
            }
            case 507003: {
                MessageMgr.sendMsgNotify((long)roleId, (int)141219, null);
                return;
            }
            case 507001: {
                MessageMgr.sendMsgNotify((long)roleId, (int)140752, null);
                return;
            }
            case 500099: {
                MessageMgr.sendMsgNotify((long)roleId, (int)FireProp.getIntValue((String)"message", (String)"mtgserv.buffConflict"), null);
                return;
            }
        }
    }

    public static boolean canChangeMap(long roleId, int gototype, int mapId) {
        int conflictId = Transfer.checkCanChangeMap(roleId, gototype);
        if (conflictId == 0) {
            Team team = TeamManager.selectTeamByRoleId((long)roleId);
            if (!Transfer.checkJumpMap(roleId, team, mapId)) {
                return false;
            }
            if (Transaction.current() != null) {
                new PPreGotoProcess(roleId, gototype).call();
            } else {
                try {
                    new PPreGotoProcess(roleId, gototype).submit().get();
                }
                catch (Exception e) {
                    logger.error((Object)("跳转前处理出错,roleId=" + roleId + ", gototype=" + gototype), (Throwable)e);
                }
            }
            return true;
        }
        Transfer.sendMsgWhileCanntGoto(roleId, conflictId);
        return false;
    }

    public static boolean checkJumpMap(long roleId, Team team, int mapId) {
        if (mapId == 0) {
            return true;
        }
        MapConfig cfg = (MapConfig)ConfigManager.getInstance().getConf(MapConfig.class).get(mapId);
        if (team == null || cfg == null || cfg.getSafemap() == 1) {
            return true;
        }
        boolean canJump = true;
        if (!canJump) {
            if (team.isTeamLeader(roleId)) {
                Iterator iterator = team.getNormalMemberIds().iterator();
                while (iterator.hasNext()) {
                    long id = (Long)iterator.next();
                    MessageMgr.psendMsgNotify((long)id, (int)145037, null);
                    MessageMgr.sendMsgNotify((long)id, (int)145037, null);
                }
            } else {
                MessageMgr.sendMsgNotify((long)roleId, (int)145037, null);
            }
        }
        return canJump;
    }

    public static boolean justGoto(long roleid, long sceneid, int x, int y, int gototype) {
        if (!Transfer.canChangeMap(roleid, gototype, (int)sceneid)) {
            return false;
        }
        CGPlayUtil.removeTeamMemberCGBuff((Long)roleid);
        GsClient.sendToScene((Protocol)new GGoto(roleid, sceneid, x, y, 0, gototype));
        return true;
    }

    public static boolean justGotoWhileCommit(long roleid, long sceneid, int x, int y, int gototype) {
        if (!Transfer.canChangeMap(roleid, gototype, (int)sceneid)) {
            return false;
        }
        CGPlayUtil.removeTeamMemberCGBuff((Long)roleid);
        GsClient.pSendWhileCommit((Protocol)new GGoto(roleid, sceneid, x, y, 0, gototype));
        return true;
    }

    public static boolean justGotoDelta(long roleid, long sceneid, int x, int y, int gototype, int delta) {
        if (!Transfer.canChangeMap(roleid, gototype, (int)sceneid)) {
            return false;
        }
        CGPlayUtil.removeTeamMemberCGBuff((Long)roleid);
        GsClient.sendToScene((Protocol)new GGoto(roleid, sceneid, x, y, delta, gototype));
        return true;
    }

    public static boolean justGotoDeltaWhileCommit(long roleid, long sceneid, int x, int y, int gototype, int delta) {
        if (!Transfer.canChangeMap(roleid, gototype, (int)sceneid)) {
            return false;
        }
        CGPlayUtil.removeTeamMemberCGBuff((Long)roleid);
        GsClient.pSendWhileCommit((Protocol)new GGoto(roleid, sceneid, x, y, delta, gototype));
        return true;
    }

    public static boolean justGotoRandom(long roleid, int sceneid, int gototype) {
        if (!Transfer.canChangeMap(roleid, gototype, sceneid)) {
            return false;
        }
        CGPlayUtil.removeTeamMemberCGBuff((Long)roleid);
        GsClient.sendToScene((Protocol)new GGotoRandom(roleid, (long)sceneid, gototype));
        return true;
    }

    public static boolean justGotoRandomWhileCommit(long roleid, int sceneid, int gototype) {
        if (!Transfer.canChangeMap(roleid, gototype, sceneid)) {
            return false;
        }
        CGPlayUtil.removeTeamMemberCGBuff((Long)roleid);
        GsClient.pSendWhileCommit((Protocol)new GGotoRandom(roleid, (long)sceneid, gototype));
        return true;
    }

    public static boolean justGotoRandom(long roleid, int sceneid, int leftTopx, int leftTopy, int lenX, int lenY, int gototype) {
        if (!Transfer.canChangeMap(roleid, gototype, sceneid)) {
            return false;
        }
        CGPlayUtil.removeTeamMemberCGBuff((Long)roleid);
        GsClient.sendToScene((Protocol)new GGotoRandomInARegion(roleid, (long)sceneid, leftTopx, leftTopy, lenX, lenY, gototype));
        return true;
    }

    public static boolean justGotoRandomWhileCommit(long roleid, int sceneid, int leftTopx, int leftTopy, int lenX, int lenY, int gototype) {
        if (!Transfer.canChangeMap(roleid, gototype, sceneid)) {
            return false;
        }
        CGPlayUtil.removeTeamMemberCGBuff((Long)roleid);
        GsClient.pSendWhileCommit((Protocol)new GGotoRandomInARegion(roleid, (long)sceneid, leftTopx, leftTopy, lenX, lenY, gototype));
        return true;
    }
}

